  processor 6502                        ;Cuckoo clock for Commodore Vic20
                                        ;(8kB RAM expansion)
  org $1201

  hex 0b12 cd07 9e 34363231 000000

  sei
  lda #<irq$
  sta 788
  lda #>irq$
  sta 789
  lda #$7f
  sta $911e
  lda #<nmi$
  sta 792
  lda #>nmi$
  sta 793
  lda #98
  sta $9114
  lda #0
  sta $9115
  lda #$40
  sta $911b
  cli
  lda #<text$
  ldy #>text$
  jmp $cb1e

text$
  dc.b "CUCKOO CLOCK FOR VIC20"
  dc.b "WRITTEN BY TIMO RAITA "
  dc.b "<VIC@IKI.FI>.",0

irq$
  ldx #0
check$
  lda hi$,x
  cmp 160
  bne nohit$
  lda mid$,x
  cmp 161
  bne nohit$
  lda lo$,x
  cmp 162
  bne nohit$
  lda c$,x
  sta count$
  lda #$c0
  sta $911e
  jmp $eabf
nohit$
  inx
  cpx #48
  bne check$
  jmp $eabf

count$
  hex 0c

nmi$
  pha
  dec counter$
  beq play2$
play1$
  jsr read$
  and #$0f
  sta 36878
ack$
  lda $9114
  pla
  rti

play2$
  lda #2
  sta counter$
  jsr read$
  and #$f0
  lsr
  lsr
  lsr
  lsr
  sta 36878
  inc read$+1
  bne nopbc$
  inc read$+2
nopbc$
  lda read$+1
  cmp #<end$
  bne noend$
  lda read$+2
  cmp #>end$
  bne noend$
  lda #<(sample$+2)
  sta read$+1
  lda #>(sample$+2)
  sta read$+2
  dec count$
  bne noend$
  lda #$7f
  sta $911e
noend$
  lda $9114
  pla
  rti

read$
  lda sample$+2
  rts

counter$
  hex 02

lo$
  hex 00 E0 C0 A0 80 60 40 20 00 E0 C0 A0 80 60 40 20 00 E0 C0 A0 80 60 40 20
  hex 00 E0 C0 A0 80 60 40 20 00 E0 C0 A0 80 60 40 20 00 E0 C0 A0 80 60 40 20 
mid$
  hex 00 A5 4B F1 97 3D E3 89 2F D4 7A 20 C6 6C 12 B8 5E 03 A9 4F F5 9B 41 E7
  hex 8D 32 D8 7E 24 CA 70 16 BC 61 07 AD 53 F9 9F 45 EB 90 36 DC 82 28 CE 74 
hi$
  hex 00 01 03 04 06 08 09 0B 0D 0E 10 12 13 15 17 18 1A 1C 1D 1F 20 22 24 25
  hex 27 29 2A 2C 2E 2F 31 33 34 36 38 39 3B 3C 3E 40 41 43 45 46 48 4A 4B 4D 
c$
  hex 0C 01 01 01 02 01 03 01 04 01 05 01 06 01 07 01 08 01 09 01 0A 01 0B 01
  hex 0C 01 01 01 02 01 03 01 04 01 05 01 06 01 07 01 08 01 09 01 0A 01 0B 01 

sample$
  incbin "sample.bin"
end$
